/**********************************************************************
 * imap4_in.h                                            September 1999
 * Horms                                             horms@vergenet.net
 *
 * Handle IMAP4 commands from a client
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef POP3_IN_BLUM
#define POP3_IN_BLUM

#include <pwd.h>
#include <sys/types.h>

#ifdef HAVE_CONFIG_H
#include "../config.h" 
#endif

#include "perdition_types.h"
#include "queue.h"
#include "token.h"
#include "imap4_write.h"
#include "log.h"
#include "daemon.h"
#include "queue_func.h"
#include "pam.h"


struct passwd *imap4_in_get_pw(
  const int in_fd, 
  const int out_fd,
  token_t **return_tag
);

int imap4_in_authenticate(
  const struct passwd *pw, 
  const int out_fd,
  const token_t *tag
);

  
int imap4_in_greeting(const int fd);

int imap4_in_noop(const int fd, const token_t *tag);

int imap4_in_capability(const int fd, const token_t *tag);

int imap4_in_authenticate_cmd(const int fd, const token_t *tag);

int imap4_in_logout(const int fd, const token_t *tag);
#endif
