/**********************************************************************
 * options.h                                                   May 1999
 * Horms                                             horms@vergenet.net
 *
 * Read in command line options
 * Code based on man getopt(3)
 *
 * Released under the terms of the GNU GPL
 **********************************************************************/

#ifndef PERDITION_OPTIONS_STIX
#define PERDITION_OPTIONS_STIX

#include <stdio.h>
#include <getopt.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include "jain.h"
#include "log.h"
#include "protocol.h"
#include "daemon.h"
#include "str.h"

#define DEFAULT_IDLE_TIMEOUT 1800 /*in seconds*/
#define DISPLAY_NULL_STR "(NULL)"

#define DEFAULT_AUTHENTICATE_IN 0
#define DEFAULT_DOMAIN_DELIMITER "@"
#define DEFAULT_CLIENT_SERVER_SPECIFICATION 0
#define DEFAULT_GROUP "nobody"
#define DEFAULT_INETD_MODE 0
#define DEFAULT_STRIP_DOMAIN 0
#define DEFAULT_MAPNAME "/etc/perdition/popmap.db"
#define DEFAULT_PROTOCOL PROTOCOL_POP3
#define DEFAULT_USERNAME "nobody"
#define DEFAULT_OUTGOING_SERVER NULL


typedef struct {
  int  authenticate_in;
  char *domain_delimiter;
  int  domain_delimiter_length;
  int  client_server_specification;
  char *group;
  int  inetd_mode;
  char *listen_port;
  char *mapname;
  char *outgoing_port;
  char *outgoing_server;
  int  protocol;
  int  strip_domain;
  char *username;
} options_t;

extern char *optarg;
extern int optind, opterr, optopt;

options_t options(int argc, char **argv);
int  log_options(options_t options);
void usage(int exit_status);

#endif
