/**********************************************************************
 * pam.c                                                     March 1999
 * Horms                                             horms@vergenet.net
 *
 * Authenticate a user using pam
 *
 * Taken fromt the pam programming guide
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/


#include "pam.h"

int pam_retval;
struct pam_conv conv_struct={perdition_conv, NULL};

int perdition_conv(
  int num_msg,
  const struct pam_message **msgm,
  struct pam_response **response,
  void *appdata_ptr
){
  char *pass;

  if((
    *response=(struct pam_response *)malloc(sizeof(struct pam_response))
  )==NULL){
    return(PAM_CONV_ERR);
  }

  (*response)->resp_retcode=0;

  if((char *)appdata_ptr==NULL){
    pass=NULL;
  }
  else if((pass=strdup((char *)appdata_ptr))==NULL){
    return(PAM_CONV_ERR);
  }

  (*response)->resp=pass;
  return(PAM_SUCCESS);
}

int do_pam_authentication(
  pam_handle_t *pamh, 
  const char *user,
  const char *pass
){
  conv_struct.appdata_ptr=(void *)pass;
  pam_retval = pam_set_item(pamh, PAM_CONV, (void *) &conv_struct);

  if (pam_retval == PAM_SUCCESS) {
    pam_retval = pam_set_item(pamh, PAM_USER, user);
  }

  if (pam_retval == PAM_SUCCESS){
    pam_retval = pam_authenticate(pamh, 0);  /* is user really user? */
  }

  if (pam_retval == PAM_SUCCESS){
    pam_retval = pam_acct_mgmt(pamh, 0);     /* permitted access? */
  }

  return ( pam_retval == PAM_SUCCESS ? 0:-1 );     /* indicate success */
}

int do_pam_end(pam_handle_t *pamh, int default_return){
  if (pam_end(pamh,pam_retval) != PAM_SUCCESS) {   /* close Linux-PAM */
    pamh = NULL;
    return(EX_PAM_ERROR);
  }
  return(default_return);
}
